Imports System
Imports System.Diagnostics
Public Class NotifyEventArgs(Of T) : Inherits EventArgs
   Public ReadOnly Value As T
   Public Sub New(ByVal Value As T)
      MyBase.New()
      Me.Value = Value
   End Sub
End Class 'NotifyEventArgs(Of T)


Public Delegate Sub EventHandlerEx(Of T0, T1 As EventArgs)(ByVal Sender As T0, ByVal e As T1)

Public Delegate Sub EventHandlerEx(Of T0)(ByVal Sender As T0)

Public Module modHelpers

   Public DebugDummi As Object

   <DebuggerStepThrough()> _
   Public Sub Nop()
   End Sub

   Public Function EnumGetName(Of T As Structure)(ByVal Value As T) As String
      Return [Enum].GetName(GetType(T), Value)
   End Function

   Public Function EnumGetValues(Of T As Structure)() As T()
      Return DirectCast([Enum].GetValues(GetType(T)), T())
   End Function

   Public Function DisposeManaged(Of T As IDisposable)( _
         ByVal disposing As Boolean, _
         ByRef First As T, _
         ByVal ParamArray Disposables As IDisposable()) As Boolean
      If Not disposing Then Return False
      If First Is Nothing Then Return False
      First.Dispose()
      First = Nothing
      For Each D As IDisposable In Disposables
         D.Dispose()
      Next
      Return True
   End Function

   Private _DbgID As Integer
   Private _Sw As New Stopwatch

   ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
   Public Sub Dbg(ByVal ParamArray Args As Object())
      DbgLine(Args)
   End Sub
   ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
   Public Sub Dbg(ByVal Args As IEnumerable)
      DbgLine(Args.Cast(Of Object))
   End Sub
   ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
   Public Sub Dbg(ByVal Args As String)
      DbgLine({Args})
   End Sub
   Private Sub DbgLine(ByVal args As IEnumerable(Of Object), ByVal ParamArray prev() As Object)
      Dim itms = New List(Of Object)(20)
      itms.Add(_DbgID)
      itms.AddRange(prev)
      itms.AddRange(From arg In args Select If(arg, "##-Null-##"))
      itms.Add("")
      Console.Write(Environment.NewLine & String.Join(" ", itms))
      _DbgID = (_DbgID + 1) Mod 10
   End Sub

   ''' <summary>initiate by calling without Args</summary>
   Public Sub DbgTime(ByVal ParamArray Args As Object())
      If Args.Length = 0 Then _Sw.Restart() : Return
      Dim time = CInt(_Sw.ElapsedMilliseconds)
      If time < 10 Then
         Console.Write(0)
         Return
      End If
      DbgLine(Args, String.Format("{0,6}", time))
   End Sub

   Public Function Msg(ByVal msg1 As String, ByVal ParamArray msgs() As String) As Microsoft.VisualBasic.MsgBoxResult
      Return Microsoft.VisualBasic.MsgBox(String.Concat(msg1, String.Concat(msgs)))
   End Function

End Module

